GeoTessCPP: geotess::GeoTessProfileConstant Class Reference

GeoTessCPP 2.2.3 Software to facilitate storage and retrieval of 3D information about the Earth.

Public Member Functions | Static Public Member Functions | List of all members
geotess::GeoTessProfileConstant Class Reference

A Profile object that defines two radii at the bottom and top of the associated layer, and a single Data object that represents the model values throughout the layer. More...

`#include <GeoTessProfileConstant.h>`

Inheritance diagram for geotess::GeoTessProfileConstant:

## Public Member Functions
| GeoTessProfileConstant (float radBot, float radTop, GeoTessData *dat)
virtual int | class_size () const
virtual LONG_INT | getMemory ()
virtual const GeoTessProfileType & | getType () const
virtual bool | operator== (const GeoTessProfile &p) const
virtual float | getRadius (int i) const
virtual int | getNRadii () const
virtual int | getNData () const
virtual float * | getRadii ()
virtual GeoTessData ** | getData ()
virtual GeoTessData * | getData (int i)
virtual const GeoTessData & | getData (int i) const
virtual void | setData (const vector< GeoTessData * > &inData)
virtual void | setData (int index, GeoTessData *inData)
virtual double | getValue (int attributeIndex, int nodeIndex) const
virtual double | getValue (const GeoTessInterpolatorType &rInterpType, int attributeIndex, double radius, bool allowRadiusOutOfRange) const
virtual double | getValueTop (int attributeIndex) const
virtual bool | isNaN (int nodeIndex, int attributeIndex)
virtual void | setRadii (const vector< float > &newRadii)
virtual void | setRadius (int index, float radius)
virtual float | getRadiusTop () const
virtual const GeoTessData & | getDataTop () const
virtual GeoTessData * | getDataTop ()
virtual float | getRadiusBottom () const
virtual const GeoTessData & | getDataBottom () const
virtual GeoTessData * | getDataBottom ()
Public Member Functions inherited from geotess::GeoTessProfile
double | getValue (const vector< int > &nodeIds, const vector< double > &coefficients, int attributeIndex) const
virtual double | getValueBottom (int attributeIndex) const
double | getThickness ()
int | getRadiusIndex (double radius) const
virtual int | getRadiusIndex (double radius, int jlo) const
virtual double | getInterpolationCoefficient (int i, double radius, bool allowOutOfRange) const
virtual int | getPointIndex (int nodeIndex) const
virtual int | findClosestRadiusIndex (double radius) const

## Static Public Member Functions
static string | class_name ()
Static Public Member Functions inherited from geotess::GeoTessProfile
static GeoTessProfile * | newProfile (const vector< float > &radii, vector< GeoTessData * > &data)
static GeoTessProfile * | newProfile (const vector< float > &radii, vector< vector< double > > &data)
static GeoTessProfile * | newProfile (const vector< float > &radii, vector< vector< float > > &data)
static GeoTessProfile * | newProfile (const vector< float > &radii, vector< vector< LONG_INT > > &data)
static GeoTessProfile * | newProfile (const vector< float > &radii, vector< vector< int > > &data)
static GeoTessProfile * | newProfile (const vector< float > &radii, vector< vector< short > > &data)
static GeoTessProfile * | newProfile (const vector< float > &radii, vector< vector< byte > > &data)
static GeoTessProfile * | newProfile (float *radii, const int &nRadii, GeoTessData **data, const int &nData)
static GeoTessProfile * | newProfile (float *radii, const int &nRadii, double **values, const int &nNodes, const int &nAttributes)
static GeoTessProfile * | newProfile (float *radii, const int &nRadii, float **values, const int &nNodes, const int &nAttributes)
static GeoTessProfile * | newProfile (float *radii, const int &nRadii, LONG_INT **values, const int &nNodes, const int &nAttributes)
static GeoTessProfile * | newProfile (float *radii, const int &nRadii, int **values, const int &nNodes, const int &nAttributes)
static GeoTessProfile * | newProfile (float *radii, const int &nRadii, short **values, const int &nNodes, const int &nAttributes)
static GeoTessProfile * | newProfile (float *radii, const int &nRadii, byte **values, const int &nNodes, const int &nAttributes)
static string | class_name ()
static int | class_count ()

## Detailed Description

A Profile object that defines two radii at the bottom and top of the associated layer, and a single Data object that represents the model values throughout the layer.

A Profile object that defines two radii, one at the bottom and other at the top of the associated layer, and a single Data object that represents the model values throughout the layer.

Definition at line 78 of file GeoTessProfileConstant.h.

## Constructor & Destructor Documentation

## ◆ GeoTessProfileConstant()

geotess::GeoTessProfileConstant::GeoTessProfileConstant | ( | float | radBot,
|  | float | radTop,
|  | GeoTessData * | dat
| ) |  |
| inline

Default constructor.

Definition at line 113 of file GeoTessProfileConstant.h.

## Member Function Documentation

## ◆ class_name()

static string geotess::GeoTessProfileConstant::class_name | ( |  | ) |
| inlinestatic

Returns the class name.

Definition at line 120 of file GeoTessProfileConstant.h.

## ◆ class_size()

virtual int geotess::GeoTessProfileConstant::class_size | ( |  | ) | const
| inlinevirtual

Returns the class size.

Reimplemented from geotess::GeoTessProfile.

Definition at line 125 of file GeoTessProfileConstant.h.

## ◆ getData() [1/3]

virtual GeoTessData** geotess::GeoTessProfileConstant::getData | ( |  | ) |
| inlinevirtual

Retrieve a shallow copy of all of the Data objects associated with this Profile.

Reimplemented from geotess::GeoTessProfile.

Definition at line 174 of file GeoTessProfileConstant.h.

## ◆ getData() [2/3]

virtual GeoTessData* geotess::GeoTessProfileConstant::getData | ( | int | i | ) |
| inlinevirtual

Retrieve a reference the i'th Data object

Reimplemented from geotess::GeoTessProfile.

Definition at line 180 of file GeoTessProfileConstant.h.

## ◆ getData() [3/3]

virtual const GeoTessData& geotess::GeoTessProfileConstant::getData | ( | int | i | ) | const
| inlinevirtual

Retrieve a reference the i'th Data object

Reimplemented from geotess::GeoTessProfile.

Definition at line 185 of file GeoTessProfileConstant.h.

## ◆ getDataBottom() [1/2]

virtual GeoTessData* geotess::GeoTessProfileConstant::getDataBottom | ( |  | ) |
| inlinevirtual

Get the Data object at the bottom of the profile.

Reimplemented from geotess::GeoTessProfile.

Definition at line 306 of file GeoTessProfileConstant.h.

## ◆ getDataBottom() [2/2]

virtual const GeoTessData& geotess::GeoTessProfileConstant::getDataBottom | ( |  | ) | const
| inlinevirtual

Get the Data object at the bottom of the profile.

Reimplemented from geotess::GeoTessProfile.

Definition at line 301 of file GeoTessProfileConstant.h.

## ◆ getDataTop() [1/2]

virtual GeoTessData* geotess::GeoTessProfileConstant::getDataTop | ( |  | ) |
| inlinevirtual

Get the Data object at the top of the profile.

Reimplemented from geotess::GeoTessProfile.

Definition at line 291 of file GeoTessProfileConstant.h.

## ◆ getDataTop() [2/2]

virtual const GeoTessData& geotess::GeoTessProfileConstant::getDataTop | ( |  | ) | const
| inlinevirtual

Get the Data object at the top of the profile.

Reimplemented from geotess::GeoTessProfile.

Definition at line 286 of file GeoTessProfileConstant.h.

## ◆ getMemory()

virtual LONG_INT geotess::GeoTessProfileConstant::getMemory | ( |  | ) |
| inlinevirtual

Reimplemented from geotess::GeoTessProfile.

Definition at line 128 of file GeoTessProfileConstant.h.

## ◆ getNData()

virtual int geotess::GeoTessProfileConstant::getNData | ( |  | ) | const
| inlinevirtual

Get the number of Data objects that comprise this profile.

Reimplemented from geotess::GeoTessProfile.

Definition at line 163 of file GeoTessProfileConstant.h.

## ◆ getNRadii()

virtual int geotess::GeoTessProfileConstant::getNRadii | ( |  | ) | const
| inlinevirtual

Get the number of radii that comprise this profile.

Reimplemented from geotess::GeoTessProfile.

Definition at line 158 of file GeoTessProfileConstant.h.

## ◆ getRadii()

virtual float* geotess::GeoTessProfileConstant::getRadii | ( |  | ) |
| inlinevirtual

Retrieve a deep copy of the radii values in km.

Reimplemented from geotess::GeoTessProfile.

Definition at line 168 of file GeoTessProfileConstant.h.

## ◆ getRadius()

virtual float geotess::GeoTessProfileConstant::getRadius | ( | int | i | ) | const
| inlinevirtual

Get the i'th radius value in this profile in km. Radii are in order of increasing radius.

Reimplemented from geotess::GeoTessProfile.

Definition at line 152 of file GeoTessProfileConstant.h.

## ◆ getRadiusBottom()

virtual float geotess::GeoTessProfileConstant::getRadiusBottom | ( |  | ) | const
| inlinevirtual

Get the radius at the bottom of the profile, in km.

Reimplemented from geotess::GeoTessProfile.

Definition at line 296 of file GeoTessProfileConstant.h.

## ◆ getRadiusTop()

virtual float geotess::GeoTessProfileConstant::getRadiusTop | ( |  | ) | const
| inlinevirtual

Get the radius at the top of the profile, in km.

Reimplemented from geotess::GeoTessProfile.

Definition at line 281 of file GeoTessProfileConstant.h.

## ◆ getType()

virtual const GeoTessProfileType& geotess::GeoTessProfileConstant::getType | ( |  | ) | const
| inlinevirtual

Returns ProfileType (CONSTANT).

Returns
  ProfileType (CONSTANT).

Reimplemented from geotess::GeoTessProfile.

Definition at line 135 of file GeoTessProfileConstant.h.

## ◆ getValue() [1/2]

virtual double geotess::GeoTessProfileConstant::getValue | ( | const GeoTessInterpolatorType & | rInterpType,
|  | int | attributeIndex,
|  | double | radius,
|  | bool | allowRadiusOutOfRange
| ) |  | const
| inlinevirtual

Retrieve the value of the specified attribute interpolated at the specified radius.

Parameters

  rInterpType | either Int
  attributeIndex |
  radius | radius in km
  allowRadiusOutOfRange |

Returns
  interpolated attribute value

Reimplemented from geotess::GeoTessProfile.

Definition at line 219 of file GeoTessProfileConstant.h.

## ◆ getValue() [2/2]

virtual double geotess::GeoTessProfileConstant::getValue | ( | int | attributeIndex,
|  | int | nodeIndex
| ) |  | const
| inlinevirtual

Retrieve the value of the specified attribute interpolated from this profile at the specified radius index

Parameters

  attributeIndex |
  nodeIndex |

Returns
  double

Reimplemented from geotess::GeoTessProfile.

Definition at line 207 of file GeoTessProfileConstant.h.

## ◆ getValueTop()

virtual double geotess::GeoTessProfileConstant::getValueTop | ( | int | attributeIndex | ) | const
| inlinevirtual

Retrieve the value of the specified attribute at the top of the layer.

Parameters

  attributeIndex |

Returns
  double

Reimplemented from geotess::GeoTessProfile.

Definition at line 241 of file GeoTessProfileConstant.h.

## ◆ isNaN()

virtual bool geotess::GeoTessProfileConstant::isNaN | ( | int | nodeIndex,
|  | int | attributeIndex
| ) |  |
| inlinevirtual

Return true if the specified Data value is NaN. For doubles and floats, this means not NaN. For bytes, shorts, ints and longs, always returns false since there is no value that is NaN.

Parameters

  nodeIndex |
  attributeIndex |

Returns
  true if the specified Data value is NaN.

Reimplemented from geotess::GeoTessProfile.

Definition at line 254 of file GeoTessProfileConstant.h.

## ◆ operator==()

virtual bool geotess::GeoTessProfileConstant::operator== | ( | const GeoTessProfile & | p | ) | const
| inlinevirtual

Return true if the input Profile object (p) equals this Profile object.

Reimplemented from geotess::GeoTessProfile.

Definition at line 141 of file GeoTessProfileConstant.h.

## ◆ setData() [1/2]

virtual void geotess::GeoTessProfileConstant::setData | ( | const vector< GeoTessData * > & | inData | ) |
| inlinevirtual

Resets the data object to the new input data

Reimplemented from geotess::GeoTessProfile.

Definition at line 190 of file GeoTessProfileConstant.h.

## ◆ setData() [2/2]

virtual void geotess::GeoTessProfileConstant::setData | ( | int | index,
|  | GeoTessData * | inData
| ) |  |
| inlinevirtual

Resets the data object at index to the new input data.

Reimplemented from geotess::GeoTessProfile.

Definition at line 196 of file GeoTessProfileConstant.h.

## ◆ setRadii()

virtual void geotess::GeoTessProfileConstant::setRadii | ( | const vector< float > & | newRadii | ) |
| inlinevirtual

Replace the radii currently associated with this Profile with new values.

Reimplemented from geotess::GeoTessProfile.

Definition at line 262 of file GeoTessProfileConstant.h.

## ◆ setRadius()

virtual void geotess::GeoTessProfileConstant::setRadius | ( | int | index,
|  | float | radius
| ) |  |
| inlinevirtual

Replace the radius at the specified nodeIndex.

Reimplemented from geotess::GeoTessProfile.

Definition at line 265 of file GeoTessProfileConstant.h.

The documentation for this class was generated from the following file:

- rstt/GeoTessCPP/include/GeoTessProfileConstant.h